Index: keepalived/vrrp/vrrp.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/vrrp/vrrp.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/vrrp/vrrp.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/vrrp/vrrp.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -36,13 +36,14 @@
 #include "vrrp_data.h"
 #include "vrrp_sync.h"
 #include "vrrp_index.h"
+#include "vrrp_eric.h"
 #include "memory.h"
 #include "list.h"
+#include "main.h"
 
 /* extern global vars */
 extern vrrp_conf_data *vrrp_data;
 extern vrrp_conf_data *old_vrrp_data;
-extern unsigned int debug;
 
 /* compute checksum */
 static u_short
@@ -175,7 +176,7 @@
 	memset(ah->auth_data, 0, sizeof (ah->auth_data));
 
 	/* Compute the ICV */
-	hmac_md5(buffer,
+	_hmac_md5(buffer,
 		 vrrp_iphdr_len(vrrp) + vrrp_ipsecah_len() + vrrp_hd_len(vrrp)
 		 , vrrp->auth_data, sizeof (vrrp->auth_data)
 		 , digest);
@@ -284,10 +285,18 @@
 		}
 	}
 
+	/* rwa: MUST verify that the build_nr is valid on the receiving interface */
+	if (vrrp_eric_build_nr != hd->build_nr) {
+		syslog(LOG_INFO,
+		       "received build number mismatch. Received %u, Expected %u",
+		       hd->build_nr, vrrp_eric_build_nr);
+		return VRRP_PACKET_DROP;
+	}
+
 	/* MUST verify that the VRID is valid on the receiving interface */
 	if (vrrp->vrid != hd->vrid) {
 		syslog(LOG_INFO,
-		       "received VRID mismatch. Received %d, Expected %d",
+		       "received VRID mismatch. Received 0x%llx, Expected 0x%llx",
 		       hd->vrid, vrrp->vrid);
 		return VRRP_PACKET_DROP;
 	}
@@ -297,7 +306,7 @@
 		 * MAY verify that the IP address(es) associated with the
 		 * VRID are valid
 		 */
-		if (hd->naddr != LIST_SIZE(vrrp->vip)) {
+		if (1 != LIST_SIZE(vrrp->vip)) {
 			syslog(LOG_INFO,
 			       "receive an invalid ip number count associated with VRID!");
 			return VRRP_PACKET_KO;
@@ -315,10 +324,6 @@
 				return VRRP_PACKET_KO;
 			}
 		}
-	} else if (hd->naddr > 0) {
-		syslog(LOG_INFO,
-		       "receive an invalid ip number count associated with VRID!");
-		return VRRP_PACKET_KO;
 	}
 
 	/*
@@ -438,7 +443,7 @@
 	   -- rfc2402.3.3.3.1.1.1 & rfc2401.5
 	 */
 	digest = (unsigned char *) MALLOC(16 * sizeof (unsigned char *));
-	hmac_md5(buffer, buflen, vrrp->auth_data, sizeof (vrrp->auth_data)
+	_hmac_md5(buffer, buflen, vrrp->auth_data, sizeof (vrrp->auth_data)
 		 , digest);
 	memcpy(ah->auth_data, digest, HMAC_MD5_TRUNC);
 
@@ -455,16 +460,16 @@
 static int
 vrrp_build_vrrp(vrrp_rt * vrrp, int prio, char *buffer, int buflen)
 {
-	int i = 0;
 	vrrp_pkt *hd = (vrrp_pkt *) buffer;
+	int i = 0;
 	uint32_t *iparr = (uint32_t *) ((char *) hd + sizeof (*hd));
 	element e;
 	ip_address *ip_addr;
 
 	hd->vers_type = (VRRP_VERSION << 4) | VRRP_PKT_ADVERT;
+	hd->build_nr = vrrp_eric_build_nr;
 	hd->vrid = vrrp->vrid;
 	hd->priority = prio;
-	hd->naddr = (!LIST_ISEMPTY(vrrp->vip)) ? LIST_SIZE(vrrp->vip) : 0;
 	hd->auth_type = vrrp->auth_type;
 	hd->adver_int = vrrp->adver_int / TIMER_HZ;
 
@@ -759,12 +764,14 @@
 		       vrrp->iname);
 		vrrp->ms_down_timer =
 		    3 * vrrp->adver_int + VRRP_TIMER_SKEW(vrrp);
-	} else if (hd->priority == 0) {
+	} else if (hd->build_nr == vrrp_eric_build_nr && hd->priority == 0) {
 		vrrp->ms_down_timer = VRRP_TIMER_SKEW(vrrp);
-	} else if (!vrrp->preempt || hd->priority >= vrrp->priority) {
+	} else if (!vrrp->preempt ||
+		   hd->build_nr > vrrp_eric_build_nr ||
+		   (hd->build_nr == vrrp_eric_build_nr && hd->priority >= vrrp->priority)) {
 		vrrp->ms_down_timer =
 		    3 * vrrp->adver_int + VRRP_TIMER_SKEW(vrrp);
-	} else if (hd->priority < vrrp->priority) {
+	} else if (hd->build_nr == vrrp_eric_build_nr && hd->priority < vrrp->priority) {
 		syslog(LOG_INFO,
 		       "VRRP_Instance(%s) forcing a new MASTER election",
 		       vrrp->iname);
@@ -828,7 +835,8 @@
 		       "VRRP_Instance(%s) Dropping received VRRP packet...",
 		       vrrp->iname);
 		return 0;
-	} else if (hd->priority < vrrp->priority) {
+	} else if (hd->build_nr < vrrp_eric_build_nr ||
+		   hd->priority < vrrp->priority) {
 		/* We receive a lower prio adv we just refresh remote ARP cache */
 		syslog(LOG_INFO, "VRRP_Instance(%s) Received lower prio advert"
 		       ", forcing new election", vrrp->iname);
@@ -843,10 +851,11 @@
 		vrrp_send_adv(vrrp, vrrp->priority);
 		vrrp_send_gratuitous_arp(vrrp);
 		return 0;
-	} else if (hd->priority == 0) {
+	} else if (hd->build_nr == vrrp_eric_build_nr && hd->priority == 0) {
 		vrrp_send_adv(vrrp, vrrp->priority);
 		return 0;
-	} else if (hd->priority > vrrp->priority ||
+	} else if (hd->build_nr > vrrp_eric_build_nr ||
+		   hd->priority > vrrp->priority ||
 		   (hd->priority == vrrp->priority &&
 		    ntohl(iph->saddr) > VRRP_PKT_SADDR(vrrp))) {
 		syslog(LOG_INFO,
@@ -897,8 +906,10 @@
 		       "VRRP_Instance(%s) Dropping received VRRP packet...",
 		       vrrp->iname);
 		return 0;
-	} else if (vrrp->priority > hd->priority ||
-		   hd->priority == VRRP_PRIO_OWNER)
+	} else if (vrrp_eric_build_nr > hd->build_nr ||
+		   (vrrp_eric_build_nr == hd->build_nr &&
+		    (vrrp->priority > hd->priority ||
+		     hd->priority == VRRP_PRIO_OWNER)))
 		return 1;
 
 	return 0;
Index: keepalived/vrrp/vrrp_arp.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/vrrp/vrrp_arp.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/vrrp/vrrp_arp.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/vrrp/vrrp_arp.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -30,6 +30,10 @@
 #include "memory.h"
 #include "utils.h"
 
+/* global vars */
+char *garp_buffer;
+int garp_fd;
+
 /* Make shared socket */
 void gratuitous_arp_init(void)
 {
Index: keepalived/vrrp/vrrp_daemon.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/vrrp/vrrp_daemon.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/vrrp/vrrp_daemon.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/vrrp/vrrp_daemon.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -22,6 +22,7 @@
  * Copyright (C) 2001-2004 Alexandre Cassen, <acassen@linux-vs.org>
  */
 
+#include "vrrp_eric.h"
 #include "vrrp_daemon.h"
 #include "vrrp_scheduler.h"
 #include "vrrp_if.h"
@@ -39,14 +40,13 @@
   #include "ipvswrapper.h"
 #endif
 #include "list.h"
+#include "main.h"
 #include "memory.h"
 #include "parser.h"
 #include "watchdog.h"
 
 /* Global vars */
-vrrp_conf_data *vrrp_data;
-vrrp_conf_data *old_vrrp_data;
-int vrrp_wdog_sd = -1;
+static int vrrp_wdog_sd = -1;
 
 /* VRRP watchdog data */
 wdog_data vrrp_wdog_data = {
@@ -60,11 +60,9 @@
 /* Externals vars */
 extern thread_master *master;
 extern conf_data *data;
-extern unsigned int debug;
 extern int reload;
 extern pid_t vrrp_child;
 extern char *conf_file;
-extern int wdog_delay_vrrp;
 
 /* Daemon stop sequence */
 static void
@@ -160,6 +158,9 @@
 	/* Register vrrp software watchdog */
 	vrrp_wdog_sd = wdog_init(WDOG_VRRP);
 
+	/* Init & start the VRRP eric watcher */
+	thread_add_event(master, vrrp_eric_watch_init, NULL, 0);
+
 	/* Init & start the VRRP packet dispatcher */
 	thread_add_event(master, vrrp_dispatcher_init, NULL,
 			 VRRP_DISPATCHER);
Index: keepalived/vrrp/vrrp_data.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/vrrp/vrrp_data.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/vrrp/vrrp_data.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/vrrp/vrrp_data.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -29,6 +29,11 @@
 #include "memory.h"
 #include "utils.h"
 
+/* global vars */
+vrrp_conf_data *vrrp_data = NULL;
+vrrp_conf_data *old_vrrp_data = NULL;
+char *vrrp_buffer;
+
 /* Externals vars */
 extern vrrp_conf_data *vrrp_data;
 
@@ -133,7 +138,7 @@
 	if (vrrp->garp_delay)
 		syslog(LOG_INFO, "   Gratuitous ARP delay = %d",
 		       vrrp->garp_delay/TIMER_HZ);
-	syslog(LOG_INFO, "   Virtual Router ID = %d", vrrp->vrid);
+	syslog(LOG_INFO, "   Virtual Router ID = 0x%llx", vrrp->vrid);
 	syslog(LOG_INFO, "   Priority = %d", vrrp->priority);
 	syslog(LOG_INFO, "   Advert interval = %dsec",
 	       vrrp->adver_int / TIMER_HZ);
@@ -275,7 +280,7 @@
 
 	new = (vrrp_conf_data *) MALLOC(sizeof (vrrp_conf_data));
 	new->vrrp = alloc_list(free_vrrp, dump_vrrp);
-	new->vrrp_index = alloc_mlist(NULL, NULL, 255);
+	new->vrrp_index = alloc_mlist(NULL, NULL, 256);
 	new->vrrp_index_fd = alloc_mlist(NULL, NULL, 1024+1);
 	new->vrrp_sync_group = alloc_list(free_vgroup, dump_vgroup);
 
@@ -287,7 +292,7 @@
 {
 	free_list(vrrp_data->static_addresses);
 	free_list(vrrp_data->static_routes);
-	free_mlist(vrrp_data->vrrp_index, 255);
+	free_mlist(vrrp_data->vrrp_index, 256);
 	free_mlist(vrrp_data->vrrp_index_fd, 1024+1);
 	free_list(vrrp_data->vrrp);
 	free_list(vrrp_data->vrrp_sync_group);
Index: keepalived/vrrp/vrrp_eric.c
===================================================================
RCS file: keepalived/vrrp/vrrp_eric.c
diff -N keepalived/vrrp/vrrp_eric.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ keepalived/vrrp/vrrp_eric.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -0,0 +1,75 @@
+#include <errno.h>
+#include <string.h>
+#include <time.h>
+#include <syslog.h>
+#include <sys/ipc.h>
+#include <sys/msg.h>
+#include <sys/time.h>
+#include <sys/types.h>
+
+#include "vrrp.h"
+
+#define PP_KEEPALIVED_ERIC_WATCH_QUEUE_KEY	0x64387148
+#define PP_KEEPALIVED_ERIC_WATCH_QUEUE_PERMS	0600
+#define PP_ERIC_TIMEOUT				4
+
+struct my_msgbuf {
+    long mtype;					/* type of received/sent message */
+    struct {
+	time_t send_time;
+	unsigned int build_nr;
+    } mtext;
+};
+
+unsigned int vrrp_eric_build_nr = 0;
+static time_t last_sign_of_life = 0;
+static int msg_queue = -1;
+
+static int vrrp_eric_watch_thread(thread * thread);
+
+int
+vrrp_eric_watch_init(thread * thread)
+{
+    if ((msg_queue = msgget(PP_KEEPALIVED_ERIC_WATCH_QUEUE_KEY,
+			    PP_KEEPALIVED_ERIC_WATCH_QUEUE_PERMS | IPC_CREAT)) == -1) {
+	syslog(LOG_INFO, "VRRP: Cannot get/create msg queue for watching eric process (%s).", strerror(errno));
+	return 0;
+    }
+
+    /* register watch thread */
+    thread_add_timer(master, vrrp_eric_watch_thread, NULL, HZ);
+    
+    return 1;
+}
+
+int
+vrrp_eric_is_alive(void)
+{
+    return (((u_long)time(NULL) - (u_long)last_sign_of_life) < PP_ERIC_TIMEOUT) ? 1 : 0;
+}
+
+static int
+vrrp_eric_watch_thread(thread * thread)
+{
+    static int last_state = -1;
+    int curr_state;
+
+    if (msg_queue >= 0) {
+	struct my_msgbuf msg;
+	while (msgrcv(msg_queue, &msg, sizeof(msg.mtext), 1, IPC_NOWAIT) == sizeof(msg.mtext)) {
+	    last_sign_of_life = msg.mtext.send_time;
+	    vrrp_eric_build_nr =  msg.mtext.build_nr;
+	}
+    }
+
+    if ((curr_state = vrrp_eric_is_alive()) != last_state) {
+	last_state = curr_state;
+	syslog(LOG_INFO, "VRRP: eric process %s\n", curr_state ? "is alive" : "not responding");
+    }
+
+    /* register next watch thread */
+    thread_add_timer(thread->master, vrrp_eric_watch_thread, NULL, TIMER_HZ);
+
+    return 0;
+}
+
Index: keepalived/vrrp/vrrp_if.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/vrrp/vrrp_if.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/vrrp/vrrp_if.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/vrrp/vrrp_if.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -57,8 +57,7 @@
 #include "utils.h"
 
 /* Global vars */
-extern thread_master *master;
-extern vrrp_conf_data *vrrp_data;
+list if_queue;
 static struct ifreq ifr;
 
 /* Helper functions */
@@ -128,6 +127,10 @@
 	int mii_reg;
 	uint16_t bmsr, new_bmsr;
 
+#ifdef PP_FEAT_ETH_MAC_DIRECT_CONNECT
+	/* no MII transceiver - assume link is up */
+	return LINK_UP;
+#else
 	/* Reset MII registers */
 	memset(mii_regs, 0, sizeof (mii_regs));
 
@@ -159,6 +162,7 @@
 		return LINK_UP;
 	else
 		return LINK_DOWN;
+#endif
 }
 
 int
Index: keepalived/vrrp/vrrp_index.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/vrrp/vrrp_index.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/vrrp/vrrp_index.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/vrrp/vrrp_index.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -29,22 +29,19 @@
 #include "memory.h"
 #include "list.h"
 
-/* Externals vars */
-extern vrrp_conf_data *vrrp_data;
-
 /* VRID hash table */
 void
 alloc_vrrp_bucket(vrrp_rt *vrrp)
 {
-	list_add(&vrrp_data->vrrp_index[vrrp->vrid], vrrp);
+	list_add(&vrrp_data->vrrp_index[vrrp->vrid % 256], vrrp);
 }
 
 vrrp_rt *
-vrrp_index_lookup(const int vrid, const int fd)
+vrrp_index_lookup(const uint64_t vrid, const int fd)
 {
 	vrrp_rt *vrrp;
 	element e;
-	list l = &vrrp_data->vrrp_index[vrid];
+	list l = &vrrp_data->vrrp_index[vrid % 256];
 
 	/* return if list is empty */
 	if (LIST_ISEMPTY(l))
@@ -56,17 +53,17 @@
 	 */
 	if (LIST_SIZE(l) == 1) {
 		vrrp = ELEMENT_DATA(LIST_HEAD(l));
-		return (vrrp->fd_in == fd) ? vrrp : NULL;
+		return (vrid == vrrp->vrid && vrrp->fd_in == fd) ? vrrp : NULL;
 	}
 
 	/*
 	 * List collision on the vrid bucket. The same
-	 * vrid is used on a different interface. We perform
-	 * a fd lookup as collisions solver.
+	 * vrid is used on a different interface or a hash collision occured.
+	 * We perform a vrid compare and fd lookup as collisions solver.
 	 */ 
 	for (e = LIST_HEAD(l); e; ELEMENT_NEXT(e)) {
 		vrrp =  ELEMENT_DATA(e);
-		if (vrrp->fd_in == fd)
+		if (vrid == vrrp->vrid && vrrp->fd_in == fd)
 			return vrrp;
 	}
 
Index: keepalived/vrrp/vrrp_ipaddress.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/vrrp/vrrp_ipaddress.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/vrrp/vrrp_ipaddress.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/vrrp/vrrp_ipaddress.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -29,10 +29,6 @@
 #include "memory.h"
 #include "utils.h"
 
-/* extern global vars */
-extern vrrp_conf_data *vrrp_data;
-extern vrrp_conf_data *old_vrrp_data;
-
 /* Add/Delete IP address to a specific interface */
 int
 netlink_address_ipv4(ip_address *ipaddr, int cmd)
Index: keepalived/vrrp/vrrp_iproute.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/vrrp/vrrp_iproute.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/vrrp/vrrp_iproute.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/vrrp/vrrp_iproute.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -30,10 +30,6 @@
 #include "memory.h"
 #include "utils.h"
 
-/* extern global vars */
-extern vrrp_conf_data *vrrp_data;
-extern vrrp_conf_data *old_vrrp_data;
-
 /* Add/Delete IP route to/from a specific interface */
 int
 netlink_route_ipv4(ip_route *iproute, int cmd)
Index: keepalived/vrrp/vrrp_ipsecah.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/vrrp/vrrp_ipsecah.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/vrrp/vrrp_ipsecah.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/vrrp/vrrp_ipsecah.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -29,7 +29,7 @@
 
 /* hmac_md5 computation according to the RFCs 2085 & 2104 */
 void
-hmac_md5(unsigned char *buffer, int buffer_len, unsigned char *key, int key_len,
+_hmac_md5(unsigned char *buffer, int buffer_len, unsigned char *key, int key_len,
 	 unsigned char *digest)
 {
 	MD5_CTX context;
Index: keepalived/vrrp/vrrp_netlink.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/vrrp/vrrp_netlink.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/vrrp/vrrp_netlink.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/vrrp/vrrp_netlink.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -45,7 +45,8 @@
 #include "utils.h"
 
 /* Global vars */
-extern thread_master *master;
+struct nl_handle nl_kernel;      /* Kernel reflection channel */
+struct nl_handle nl_cmd; /* Command channel */
 
 /* Create a socket to netlink interface */
 int
Index: keepalived/vrrp/vrrp_parser.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/vrrp/vrrp_parser.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/vrrp/vrrp_parser.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/vrrp/vrrp_parser.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -35,10 +35,6 @@
 #include "parser.h"
 #include "memory.h"
 
-/* global defs */
-extern vrrp_conf_data *vrrp_data;
-extern unsigned long mem_allocated;
-
 /* Static addresses handler */
 static void
 static_addresses_handler(vector strvec)
@@ -141,13 +137,14 @@
 static void
 vrrp_vrid_handler(vector strvec)
 {
+	char * endptr;
 	vrrp_rt *vrrp = LIST_TAIL_DATA(vrrp_data->vrrp);
-	vrrp->vrid = atoi(VECTOR_SLOT(strvec, 1));
+	vrrp->vrid = strtoull(VECTOR_SLOT(strvec, 1), &endptr, 0);
 
-	if (VRRP_IS_BAD_VID(vrrp->vrid)) {
+	if (*endptr != '\0' || VRRP_IS_BAD_VID(vrrp->vrid)) {
 		syslog(LOG_INFO, "VRRP Error : VRID not valid !\n");
 		syslog(LOG_INFO,
-		       "             must be between 1 & 255. reconfigure !\n");
+		       "             must be between 1 and 2^64-1. reconfigure !\n");
 	} else
 		alloc_vrrp_bucket(vrrp);
 }
Index: keepalived/vrrp/vrrp_scheduler.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/vrrp/vrrp_scheduler.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/vrrp/vrrp_scheduler.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/vrrp/vrrp_scheduler.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -22,6 +22,7 @@
  * Copyright (C) 2001-2004 Alexandre Cassen, <acassen@linux-vs.org>
  */
 
+#include "vrrp_eric.h"
 #include "vrrp_scheduler.h"
 #include "vrrp_ipsecah.h"
 #include "vrrp_if.h"
@@ -34,13 +35,9 @@
 #include "ipvswrapper.h"
 #include "memory.h"
 #include "list.h"
+#include "main.h"
 #include "smtp.h"
 
-/* Externals vars */
-extern thread_master *master;
-extern vrrp_conf_data *vrrp_data;
-extern unsigned int debug;
-
 /* VRRP FSM (Finite State Machine) design.
  *
  * The state transition diagram implemented is :
@@ -268,14 +265,14 @@
 	return (vrrp_long < 0) ? TIMER_MAX_SEC : vrrp_long;
 }
 
-static int
+static uint64_t
 vrrp_timer_vrid_timeout(const int fd)
 {
 	vrrp_rt *vrrp;
 	element e;
 	list l = &vrrp_data->vrrp_index_fd[fd%1024 + 1];
 	TIMEVAL timer;
-	int vrid = 0;
+	uint64_t vrid = 0;
 
 	/* Multiple instances on the same interface */
 	TIMER_RESET(timer);
@@ -525,8 +522,8 @@
 static void
 vrrp_leave_master(vrrp_rt * vrrp, char *vrrp_buffer, int len)
 {
-	if (!VRRP_ISUP(vrrp)) {
-		vrrp_log_int_down(vrrp);
+	if (!VRRP_ISUP(vrrp) || !vrrp_eric_is_alive()) {
+		if (!VRRP_ISUP(vrrp)) vrrp_log_int_down(vrrp);
 		vrrp->wantstate = VRRP_STATE_GOTO_FAULT;
 		vrrp_state_leave_master(vrrp);
 	} else if (vrrp_state_master_rx(vrrp, vrrp_buffer, len)) {
@@ -551,7 +548,7 @@
 static void
 vrrp_leave_fault(vrrp_rt * vrrp, char *vrrp_buffer, int len)
 {
-	if (!VRRP_ISUP(vrrp))
+	if (!VRRP_ISUP(vrrp) || !vrrp_eric_is_alive())
 		return;
 
 	if (vrrp_state_fault_rx(vrrp, vrrp_buffer, len)) {
@@ -588,8 +585,8 @@
 static void
 vrrp_goto_master(vrrp_rt * vrrp)
 {
-	if (!VRRP_ISUP(vrrp)) {
-		vrrp_log_int_down(vrrp);
+	if (!VRRP_ISUP(vrrp) || !vrrp_eric_is_alive()) {
+	    if (!VRRP_ISUP(vrrp)) vrrp_log_int_down(vrrp);
 		syslog(LOG_INFO, "VRRP_Instance(%s) Now in FAULT state",
 		       vrrp->iname);
 		vrrp->state = VRRP_STATE_FAULT;
@@ -625,8 +622,8 @@
 {
 	/* Check if interface we are running on is UP */
 	if (vrrp->wantstate != VRRP_STATE_GOTO_FAULT) {
-		if (!VRRP_ISUP(vrrp)) {
-			vrrp_log_int_down(vrrp);
+		if (!VRRP_ISUP(vrrp) || !vrrp_eric_is_alive()) {
+			if (!VRRP_ISUP(vrrp)) vrrp_log_int_down(vrrp);
 			vrrp->wantstate = VRRP_STATE_GOTO_FAULT;
 		}
 	}
@@ -676,9 +673,9 @@
 				vgroup->state = vrrp->init_state;
 		} else
 			return;
-	} else if (VRRP_ISUP(vrrp))
-		vrrp_log_int_up(vrrp);
-	else
+	} else if (VRRP_ISUP(vrrp) && vrrp_eric_is_alive()) {
+		if (VRRP_ISUP(vrrp)) vrrp_log_int_up(vrrp);
+	} else
 		return;
 
 	/* refresh the multicast fd */
@@ -708,7 +705,7 @@
 vrrp_dispatcher_read_to(int fd)
 {
 	vrrp_rt *vrrp;
-	int vrid = 0;
+	uint64_t vrid = 0;
 	int prev_state = 0;
 
 	/* Searching for matching instance */
Index: keepalived/vrrp/vrrp_sync.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/vrrp/vrrp_sync.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/vrrp/vrrp_sync.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/vrrp/vrrp_sync.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -28,10 +28,6 @@
 #include "vrrp_data.h"
 #include "smtp.h"
 
-/* Externals vars */
-extern thread_master *master;
-extern vrrp_conf_data *vrrp_data;
-
 /* Compute the new instance sands */
 void
 vrrp_init_instance_sands(vrrp_rt * vrrp)
Index: lib/html.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/lib/html.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- lib/html.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ lib/html.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -75,8 +75,13 @@
 	begin = buffer;
 	while (buffer < end && *buffer++ != ' ')
 		inc++;
-	strncat(buf_code, begin, inc);
-	inc = atoi(buf_code);
+	if (inc > 0 && inc < 10) {
+		strncat(buf_code, begin, inc);
+		buf_code[inc] = 0;
+		inc = atoi(buf_code);
+	} else {
+		inc = 0;
+	}
 	FREE(buf_code);
 	return inc;
 }
@@ -86,11 +91,11 @@
 {
 	char *end = buffer + size_buffer;
 
-	while (buffer < end &&
-	       !(*buffer++ == '\n' &&
-		(*buffer == '\n' || (*buffer++ == '\r' && *buffer == '\n')))) ;
-
-	if (*buffer == '\n')
-		return buffer + 1;
+	while ((buffer + 4) < end) {
+		if (*buffer == '\r' && *(buffer+1) == '\n'
+		    && *(buffer+2) == '\r' && *(buffer+3) == '\n')
+			return buffer + 4;
+		buffer++;
+	}
 	return NULL;
 }
Index: lib/memory.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/lib/memory.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- lib/memory.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ lib/memory.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -25,6 +25,9 @@
  */
 
 #include "memory.h"
+#include "utils.h"
+
+unsigned long mem_allocated = 0; /* Total memory used in Bytes */
 
 void *
 xalloc(unsigned long size)
@@ -138,7 +141,7 @@
 	if (i == number_alloc_list)
 		number_alloc_list++;
 
-	assert(number_alloc_list > MAX_ALLOC_LIST);
+	assert(number_alloc_list < MAX_ALLOC_LIST);
 
 	alloc_list[i].ptr = buf;
 	alloc_list[i].size = size;
Index: lib/memory.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/lib/memory.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- lib/memory.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ lib/memory.h	21 Apr 2005 12:00:01 -0000	1.2
@@ -33,11 +33,7 @@
 #include <string.h>
 #include <assert.h>
 
-/* Global var */
-unsigned long mem_allocated;	/* Total memory used in Bytes */
-
 /* extern types */
-extern unsigned int debug;
 extern unsigned long mem_allocated;
 extern void *xalloc(unsigned long size);
 extern void *zalloc(unsigned long size);
Index: lib/parser.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/lib/parser.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- lib/parser.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ lib/parser.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -27,6 +27,10 @@
 #include "parser.h"
 #include "memory.h"
 
+/* global vars */
+vector keywords;
+FILE *stream;
+
 /* local vars */
 static int sublevel = 0;
 
Index: lib/parser.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/lib/parser.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- lib/parser.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ lib/parser.h	21 Apr 2005 12:00:01 -0000	1.2
@@ -54,8 +54,8 @@
 #define RELOAD_DELAY    5
 
 /* global var exported */
-vector keywords;
-FILE *stream;
+extern vector keywords;
+extern FILE *stream;
 
 /* Prototypes */
 extern void keyword_alloc(vector keywords, char *string, void (*handler) (vector));
Index: lib/scheduler.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/lib/scheduler.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- lib/scheduler.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ lib/scheduler.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -31,6 +31,9 @@
 #include "memory.h"
 #include "utils.h"
 
+/* global vars */
+thread_master *master = NULL;
+
 /* Make thread master. */
 thread_master *
 thread_make_master(void)
@@ -727,8 +730,6 @@
 }
 
 /* Our infinite scheduling loop */
-extern thread_master *master;
-extern unsigned int debug;
 void
 launch_scheduler(void)
 {
Index: lib/scheduler.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/lib/scheduler.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- lib/scheduler.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ lib/scheduler.h	21 Apr 2005 12:00:01 -0000	1.2
@@ -101,6 +101,9 @@
 #define THREAD_CHILD_PID(X) ((X)->u.c.pid)
 #define THREAD_CHILD_STATUS(X) ((X)->u.c.status)
 
+/* global vars exported */
+extern thread_master *master;
+
 /* Prototypes. */
 extern thread_master *thread_make_master(void);
 extern thread *thread_add_terminate_event(thread_master * m);
Index: lib/utils.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/lib/utils.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- lib/utils.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ lib/utils.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -22,8 +22,13 @@
  * Copyright (C) 2001-2004 Alexandre Cassen, <acassen@linux-vs.org>
  */
 
+#define _BSD_SOURCE
+#include <string.h>
 #include "utils.h"
 
+/* global vars */
+int debug = 0;
+
 /* Display a buffer into a HEXA formated output */
 void
 print_buffer(int count, char *buff)
@@ -104,8 +109,16 @@
 		return mask;
 	while (*cp != '/' && *cp != '\0')
 		cp++;
-	if (*cp == '/')
-		return atoi(++cp);
+	if (*cp == '/') {
+		struct in_addr addr;
+		if (inet_aton(++cp, &addr) != 0) {
+			int netmask = ntohl(addr.s_addr);
+			int first_bit = ffs(netmask);
+			mask = first_bit ? 33 - first_bit : 0;
+		} else {
+			return atoi(cp);
+		}
+	}
 	return mask;
 }
 
Index: lib/utils.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/lib/utils.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- lib/utils.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ lib/utils.h	21 Apr 2005 12:00:01 -0000	1.2
@@ -43,6 +43,9 @@
 #define DBG(fmt, msg...)
 #endif
 
+/* global vars exported */
+extern int debug;
+
 /* Prototypes defs */
 extern void print_buffer(int count, char *buff);
 extern char *inet_ntop2(uint32_t ip);
Index: lib/watchdog.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/lib/watchdog.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- lib/watchdog.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ lib/watchdog.c	21 Apr 2005 12:00:01 -0000	1.2
@@ -35,9 +35,8 @@
 #include "memory.h"
 #include "parser.h"
 
-/* Extern vars */
-extern thread_master *master;
-extern int reload;
+/* global vars */
+int reload = 0;
 
 /* Watchdog connection reader */
 static int
Index: lib/watchdog.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/lib/watchdog.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- lib/watchdog.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ lib/watchdog.h	21 Apr 2005 12:00:01 -0000	1.2
@@ -43,6 +43,9 @@
 #define WATCHDOG_STRING		"hello"
 #define WDOG_READ_BUFSIZ	32
 
+/* global vars exported */
+extern int reload;
+
 /* Prototypes */
 extern int wdog_init(char *path);
 extern void wdog_close(int sd, char *path);
